/**
 *  Copyright 2013 Sven Ewald
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.xmlbeam.tutorial.e11_freemind;

import org.xmlbeam.annotation.XBDocURL;
import org.xmlbeam.annotation.XBRead;
@SuppressWarnings("javadoc")
//START SNIPPET: MindMap
@XBDocURL("resource://XMLBeam.mm")
public interface MindMap {

    public interface Node {
        @XBRead("./node")
        Node[] getSubNodes();

        @XBRead("@TEXT")
        String getText();
    }
          
    @XBRead("/map/node")
    Node getRootNode();

    @XBRead("//node[@POSITION=''left'']")
    Node[] getLeftNodes();
    
    @XBRead("//node[@POSITION=''right'']")
    Node[] getRightNodes();
    
    @XBRead("count(descendant-or-self::node)")
    int getNodeCount();

}
//END SNIPPET: MindMap
